import { ResultAsync } from "neverthrow";
import { BaseContract } from "../implementations/BaseContract.js";
import { ContractsAbis } from "../interfaces/objects/index.js";
export class ERC7529Contract extends BaseContract {
    constructor(providerOrSigner, contractAddress, abi) {
        // If you provide your own ABI, we'll use that, but we have a built-in default ERC7529 ABI
        if (abi == undefined) {
            abi = ContractsAbis.ERC7529Abi.abi;
        }
        super(providerOrSigner, contractAddress, abi);
        this.providerOrSigner = providerOrSigner;
        this.contractAddress = contractAddress;
    }
    addDomain(domain, overrides) {
        return this.writeToContract("addDomain", [domain], overrides);
    }
    removeDomain(domain, overrides) {
        return this.writeToContract("removeDomain", [domain], overrides);
    }
    checkDomain(domain) {
        return ResultAsync.fromPromise(
        // returns array of domains
        this.contract.checkDomain(domain), (e) => {
            return this.generateError(e, "Unable to call checkDomain()");
        });
    }
}
//# sourceMappingURL=ERC7529Contract.js.map