var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var GasUtils_1;
import { BlockchainProviderError, EChain, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ResultAsync, errAsync, okAsync } from "neverthrow";
import { BlockchainErrorMapper } from "../implementations/BlockchainErrorMapper.js";
import { ContractOverrides } from "../interfaces/objects/index.js";
let GasUtils = GasUtils_1 = class GasUtils {
    static getGasFee(providerOrSigner) {
        return GasUtils_1.getProvider(providerOrSigner)
            .andThen((provider) => {
            return ResultAsync.fromPromise(provider.getFeeData(), (e) => {
                return BlockchainErrorMapper.buildErrorFromProviderError(EChain.DevDoodle, // TODO: There should be a better way to get the chainID
                e);
            });
        })
            .map((feeData) => {
            return new ContractOverrides(feeData.maxFeePerGas);
        });
    }
    static getGasPrice(providerOrSigner) {
        return GasUtils_1.getProvider(providerOrSigner)
            .andThen((provider) => {
            return ResultAsync.fromPromise(provider.getFeeData(), (e) => {
                return BlockchainErrorMapper.buildErrorFromProviderError(EChain.DevDoodle, // TODO: There should be a better way to get the chainID
                e);
            });
        })
            .map((feeData) => {
            return new ContractOverrides(null, feeData.gasPrice);
        });
    }
    static getProvider(providerOrSigner) {
        const provider = providerOrSigner.provider;
        if (provider == null) {
            return errAsync(new BlockchainProviderError(EChain.EthereumMainnet, "No provider available on providerOrSigner in getGasPrice"));
        }
        return okAsync(provider);
    }
};
GasUtils = GasUtils_1 = __decorate([
    injectable()
], GasUtils);
export { GasUtils };
//# sourceMappingURL=GasUtils.js.map