import { BlockchainCommonErrors, FarcasterIdRegistryContractError, FarcasterUserId, EVMAccountAddress } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../../implementations/BaseContract.js";
import { IEthersContractError } from "../../implementations/BlockchainErrorMapper.js";
import { IFarcasterIdRegistryContract } from "../../interfaces/index.js";
export declare class FarcasterIdRegistryContract extends BaseContract<FarcasterIdRegistryContractError> implements IFarcasterIdRegistryContract {
    protected providerOrSigner: ethers.Provider | ethers.Signer;
    constructor(providerOrSigner: ethers.Provider | ethers.Signer);
    idOf(ownerAddress: EVMAccountAddress): ResultAsync<FarcasterUserId | null, FarcasterIdRegistryContractError | BlockchainCommonErrors>;
    protected generateContractSpecificError(msg: string, e: IEthersContractError, transaction: ethers.Transaction | null): FarcasterIdRegistryContractError;
}
//# sourceMappingURL=FarcasterIdRegistryContract.d.ts.map