var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { KEY_REGISTRY_ADDRESS } from "@farcaster/hub-nodejs";
import { EVMContractAddress, FarcasterKeyRegistryContractError, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../../implementations/BaseContract.js";
import { ContractsAbis } from "../../interfaces/objects/index.js";
let FarcasterKeyRegistryContract = class FarcasterKeyRegistryContract extends BaseContract {
    constructor(providerOrSigner) {
        super(providerOrSigner, EVMContractAddress(KEY_REGISTRY_ADDRESS), ContractsAbis.FarcasterKeyRegistryAbi.abi);
        this.providerOrSigner = providerOrSigner;
    }
    totalKeys(fid, keyState) {
        return ResultAsync.fromPromise(this.contract.totalKeys(fid, keyState), (e) => {
            return this.generateError(e, "Unable to call totalKeys()");
        });
    }
    keysOf(fid, keyState) {
        return ResultAsync.fromPromise(this.contract.keysOf(fid, keyState), (e) => {
            return this.generateError(e, "Unable to call keysOf()");
        });
    }
    generateContractSpecificError(msg, e, transaction) {
        return new FarcasterKeyRegistryContractError(msg, e, transaction);
    }
};
FarcasterKeyRegistryContract = __decorate([
    injectable(),
    __metadata("design:paramtypes", [Object])
], FarcasterKeyRegistryContract);
export { FarcasterKeyRegistryContract };
//# sourceMappingURL=FarcasterKeyRegistryContract.js.map