import { TransactionResponseError, } from "@snickerdoodlelabs/objects";
import { ResultAsync, errAsync, okAsync } from "neverthrow";
export class WrappedTransactionResponse {
    constructor(txResponse, contractAddress, signerAddress, functionName, functionParams, abi) {
        this.txResponse = txResponse;
        this.contractAddress = contractAddress;
        this.signerAddress = signerAddress;
        this.functionName = functionName;
        this.functionParams = functionParams;
        this.abi = abi;
    }
    wait() {
        return ResultAsync.fromPromise(this.txResponse.wait(), (e) => {
            return new TransactionResponseError("Unable to call wait() for transaction response.", e.reason);
        }).andThen((receipt) => {
            if (receipt == null) {
                return errAsync(new TransactionResponseError("Unable to call wait() for transaction response; receipt is null, indicating 0 confirmations."));
            }
            return okAsync(receipt);
        });
    }
}
//# sourceMappingURL=WrappedTransactionResponse.js.map